/*   ==========================================================================

    On commence par les styles par défaut

   =========================================================================*/

/* Fonts ROBOTO */

@font-face {
    font-family: 'roboto';
    src: url('../fonts/roboto/roboto-regular.woff2?#iefix') format('woff2'),
         url('../fonts/roboto/roboto-regular.woff') format('woff'),
         url('../fonts/roboto/roboto-regular.ttf') format('truetype');
    font-weight: normal;
    font-style: normal;
}

@font-face {
   font-family: 'roboto';
   src: url('../fonts/roboto/roboto-bold.woff2?#iefix') format('woff2'),
        url('../fonts/roboto/roboto-bold.woff') format('woff'),
        url('../fonts/roboto/roboto-bold.ttf') format('truetype');
   font-weight: bold;
   font-style: normal;
}

@font-face {
    font-family: 'roboto';
    src: url('../fonts/roboto/roboto-italic.woff2?#iefix') format('woff2'),
         url('../fonts/roboto/roboto-italic.woff') format('woff'),
         url('../fonts/roboto/roboto-italic.ttf') format('truetype');
    font-weight: normal;
    font-style: italic;
}

@font-face {
    font-family: 'roboto';
    src: url('../fonts/roboto/roboto-light.woff2?#iefix') format('woff2'),
         url('../fonts/roboto/roboto-light.woff') format('woff');
    font-weight: 300;
    font-style: normal;
}


/*
  Modèle de boite : inclure padding et bordure dans les dimansions données à tous les éléments
*/
* {
  box-sizing : border-box;
}

/*
  Astuce : ramener la police par défaut à 10px (16px sur le navigateur en général, sauf si l'utilisateur modifie cette valeur)

  Défilement doux sur la page
*/
html {
    font-size : 62.5%;
    scroll-behavior: smooth;
}

body {
  min-height : 100vh;
  color: #222;
  font-size: 1.6rem; /* rem : unité proportionnelle à la taille définie sur html */
  line-height: 1.6;
  font-family: 'roboto', sans-serif;
}

a {
  color : #553b59;
}

a:hover, a:active, a:focus {
  color : #b75459;
}

::-moz-selection {
    background: #b3d4fc;
    text-shadow: none;
}

::selection {
    background: #b3d4fc;
    text-shadow: none;
}

/*
  A faire sytématiquement afin d'éviter que les images débordent
*/
img {
  max-width : 100%;
  height : auto;
}

/*
  Permet d'éviter un espace indésirable (qui ressemble à une marge verticale)
  liée à la valeur par défaut de ces éléments : baseline

  middle : Aligne le milieu de l'élément avec la hauteur donnée par la ligne de base de l'élément parent à laquelle on ajoute la moitié de sa hauteur.
*/
audio,
canvas,
iframe,
img,
svg,
video {
    vertical-align: middle;
}

iframe {
  width : 100%;
}

fieldset {
    margin: 0;
    padding: 0;
}

textarea {
    resize: vertical;
}

/*
  Il est possible de styler une balise hr
*/

hr {
    display: block;
    height: 1px;
    border: 0;
    border-top: 1px solid #ccc;
    margin: 1em 0;
    padding: 0;
}

/*
  Une seule règle multi-sélecteur pour définir les polices
  c'est pratique, si on change de police !
*/
h1,h2,h3,figcaption {
  font-family: 'roboto', sans-serif;
}

h1,.h1 {
  font-size : 4em;
}

h2,.h2 {
  font-size : 2.5em;
}

h3,.h3 {
  font-size : 1.8em;
}

section {
  padding : 4em 0;
}

figure {
  margin : 0; /* Il y a des marges par défaut sur l'élément figure */
}


/* =========================================================================================================
                                          CLASSES GÉNÉRIQUES
                  ASSURER UNE CONTINUITÉ, UNE HOMOGENEITE DE MISE EN FORME GLOBALE
============================================================================================================ */

/* LAYOUT PRINCIPAL de la GRILLE DE MISE EN PAGE */

.container {
  max-width : 1200px; /* Eviter les lignes trop longues (peut varier en fonction du design ) */
  margin : 0 auto; /* centrer le bloc */

  /* Surtout utile si viewport <= 1200px afin que le contenu ne soit pas collé au bord */
  padding-left : 2rem;
  padding-right : 2rem;
}

/* Styles génériques à favoriser, plutôt que de cibler au cas par cas :
  on assure ainsi une continuité et on simplifie le code

  Dans un framework (BOOTSTRAP), il y en a des tas
*/

/* Alignement du texte */
.text-right {
  text-align : right;
}

.text-center {
  text-align : center;
}

/* Espacement : on pourrait en créer d'autres ! */

.m-0 {
  margin : 0;
}
.p-3 {
  padding : 3em 0;
}

/* Style des boutons */
.btn {
  display: inline-block;
  margin : 1rem 0;
  padding : 0.6em;
  color : #fff;
  text-decoration: none;
  font-weight : bold;
  text-transform: uppercase;
  border : 2px solid #fff;
  border-radius: 2px;
  will-change : background;
  transition : background 1s;
}

.btn:hover, .btn:focus, .btn:active {
  background : #b75459;
  color : #fff;
}

@media only screen and (min-width: 36em) {

  /* Classe générique : on pourrait en avoir plusieurs ! */

  .col-4 {
    width : calc( 100% / 4 - 2em );
  }

  .col-3 {
    width : calc( 100% / 3 - 2em );
  }

  .col-2 {
    width : calc( 100% / 2 - 2em );
  }

  /*
    Classe à mettre sur le parent d'un flottant pour régler toutes les conséquences inattendues du float
    Voir la séance de cours consacrée ...
  */
  .clearfix:before,
  .clearfix:after {
      content: " "; /* 1 */
      display: table; /* 2 */
  }

  .clearfix:after {
      clear: both;
  }

  .float-left {
    float : left;
    margin-right : 5%;
  }

  .float-right {
    float : right;
    margin-left : 5%;
  }

  /*
    Mise en colonne des articles de la première section avec flexbox

  */

  .flex {
    display : flex;
    flex-direction: row;
    flex-wrap : wrap; /* Mise à la ligne si cela ne rentre pas */

    /*
      Technique pour absorber les marges latérales des enfants
      afin d'aligner l'ensemble au layout principal, c'est à dire au reste de la page
    */
    margin-right : -1em;
    margin-left : -1em;
  }

  .flex-justify-sb {
    justify-content: space-between;
  }

  /* Tous les enfants du flex */
  /*
  Par défaut : flex : 0 1 auto;

  flex-grow
  -> Si tous les items sont définis à 1, chaque enfant aura le même espace
  -> Si un enfant à la valeur 2, il prendra 2 fois plus de place que les autres

  flex-shrink
  -> possibilité de rétrécir
  flex-shrink: 0 chaque item conserve une dimension fixe.
  En mettant un overflow: hidden sur le container, on résout le problème des images qui dépassent.

  flex-basis
  -> définit la taille par défaut d'un élément avant que l'espace restant soit réparti.

  flexbox ne répartit pas l’espace de manière égale entre les colonnes.
  Il cherche d’abord à savoir de combien d’espace chaque colonne a besoin,
  puis répartit l’espace qui reste via les propriétés flex-grow et flex-shrink.
  C’est la propriété flex-basis qui a la responsabilité de déterminer
  l’espace de départ dont dispose un item avant que l’espace résiduel soit réparti.

  => flex-basis : 0; pour indiquer à flexbox qu’il doit ignorer la taille par défaut du container.

*/
  .flex > * {
    flex: 1 1 0%;
    min-width: 0;
    min-height: 0;
    margin-right : 1em;
    margin-left : 1em;
  }
}


/* =============================================================================

                        PAGE-HEADER

===============================================================================*/
.page-header ,
.page-footer {
  background: #222;
  color : #fff;
}

.page-header {
  padding-top : 4em;
  padding-bottom : 4em;
}

.page-footer {
  padding-top : 2em;
  padding-bottom : 2em;
}

.page-header .container > *,
.page-footer .container > * {
  margin : 0;
}

.page-header p {
  font-size : 1.4em;
}

h1 {
  text-transform: uppercase;
}

main {
  min-height : 100vh;
}

.entry-content {
  padding : 2em 0;
}


/* =============================================================================

                        BANNIERE ET NAVIGATION

===============================================================================*/
.banner {
  padding : 1rem 0;
  background : #fff;
}
.banner a {
  text-decoration: none;
  color : #222;
  text-transform: uppercase;
}

.logo {
  display : inline-block;
  padding : 1rem;
  border : 2px solid currentColor;
  line-height : 1;
  font-size : 1.5em;
  border-radius : 2px;
  font-weight : bold;
}

@media (max-width: 1023px) {

  .button-burger {
    height: 2.4rem;
    width: 2.8rem;
    background-color: transparent;
    background-image: linear-gradient(to right, currentColor, currentColor);
    background-position: center;
    background-repeat: no-repeat;
    background-size: 100% 5px;
    padding: 0;
    outline: 0;
    border: 0;
    color: #222;
    cursor: pointer;
    -webkit-tap-highlight-color: transparent;
  }
  .button-burger::before,
  .button-burger::after {
    content: "";
    position: absolute;
    left: 0; right: 0;
    display: block;
    height: 5px;
    background: currentColor;
    transition: .25s;
    transition-property: transform, top;
    will-change: transform, top;
  }
  .button-burger::before {
    top: 0;
  }
  .button-burger::after {
    top: calc(100% - 4px);
  }

  .js-enabled html,
  .js-enabled body {
    overflow-x: hidden;
  }

  .js-enabled .button-burger {
    display: inline-block;
    position : absolute;
    right : 1em; top : 1em;
    z-index: 1;
  }

  .js-enabled .menu {
    position : absolute;
    top : 0; left :0; bottom : 0;
    padding : 1rem;
    background : #222;
    transition: transform .5s;
    will-change: transform;
    transform: translateX(-100%);
    z-index: 1;
  }

  .js-enabled .menu.is-open {
    width : 70vw;
    transform: translateX(0);
  }

  .menu .menu-link {
    display : block;
    padding : 1em 2em;
    border-bottom : 1px solid currentColor;
    color : #fff;
  }
}


@media screen and (min-width : 1024px ) {

  .banner {
    box-shadow: 0 3px 3px -3px #777;
  }

  .js-enabled .banner {
    position : fixed;
    top : 0; left : 0; right : 0;
  }

  .js-enabled .banner.home {
    position : static;
  }

  .js-enabled .home .banner-container {
    height : 15rem;
    transition: height 1s;
  }

  .banner-container {
    display: flex;
    justify-content: space-between;
    align-items: center;
    height : 5rem;
  }

  .menu {
    transform: translateX(0);
  }

  .button-burger {
    display : none;
  }

  .menu .menu-link {
    display : inline-block;
    border-bottom : 5px solid transparent;
    margin : 0 1em;
    will-change: border-bottom;
    transition : border-bottom 1s;
  }

  .menu .menu-link:hover,
  .menu .menu-link:focus,
  .menu .menu-link:active,
    .menu .menu-link.active {
    border-bottom : 5px solid currentColor;
  }

}
